                                                                                                                                                                                                       LoadAddOn('Blizzard_TradeSkillUI')

savedCats = { }

local me;
local myRealm;
local TSHook 		     = nil                                    -- THIS IS THE TradeSkillReceipeList
local hookedTradeSkillReceipeList
local tradeSkillID           = nil
local tradeSkillFrame        = nil
local currentProfessionID    = nil
local currentProfessionName  = ""
local ElesButton             = nil
local ignoreSetCategory      = false
local DEBUG                  = false
local mode		     = "Learnt"
local updateTick	     = 0.4
local enabled	             = true;
local version		     = "1.5";


function ElesMod_OnLoad(self)
        self:RegisterEvent("VARIABLES_LOADED");
	
	SLASH_emod1 = "/emod"; 
        SlashCmdList["emod"] = ElesMod_Commands;
        
        ElesModFrame:Hide();
       
        tradeSkillFrame			= _G['TradeSkillFrame'];    
        TSHook				= tradeSkillFrame.RecipeList;		
        hookedTradeSkillReceipeList 	= TSHook
        
	if TSHook then 
	    hooksecurefunc(hookedTradeSkillReceipeList ,"SetCategoryCollapsed", hookedSetCategoryCollapsed) -- will be used to save information
	end
        tradeSkillFrame:HookScript("OnEvent" , TS_OnEvent_Hook)   
        TradeSkillFrame.RecipeList.LearnedTab:HookScript  ("OnClick" , TS_OnEvent_Hook); 
        TradeSkillFrame.RecipeList.UnlearnedTab:HookScript("OnClick" , TS_OnEvent_Hook); 
       
end




function ElesMod_OnEvent(event, arg1, arg2, arg3)
   me      = string.lower(GetUnitName("player"));
   myName  = GetUnitName("player");
   myRealm = GetRealmName();
   
   if (event == "VARIABLES_LOADED") then 
      DEFAULT_CHAT_FRAME:AddMessage("Elerion's Mod Loaded."); 
      
      if not savedCats then 
      	print("NO DATA!...Initialising...Setup....Done.");
      		savedCats           = { };
      		savedCats['status'] = true;
      		enabled             = true;
      else
      		if not savedCats['status'] then
	      		savedCats['status'] = "Enabled";
	      		enabled = true;
	      	else
	      		t = savedCats['status'];
	      		if t == "Enabled" then enabled = true else enabled = false; end
	      		
	      		if enabled == false then print("Eles Mod is currently Disabled.");
	      		else                     print("Eles Mod is currently Enabled."); end
      		end
      end
      
      
      if not savedCats[myRealm]     then savedCats[myRealm]     = { }     end			-- no setting for the realm
      if not savedCats[myRealm][me] then savedCats[myRealm][me] = { }     end                   -- Create for this player
      
      if sizeOfArray(savedCats[myRealm][me]) > 0 then
         print("Player "..myName.."-"..myRealm.."'s Professions:-");
         for field,value in pairs(savedCats[myRealm][me]) do
         	if not savedCats[myRealm][me][field]["id"] then
         		print("Damaged Profession detected.");
         	else
         		print("   -> "..savedCats[myRealm][me][field]["id"])
         	end
           
         end
      else
         print("No saved professions for player "..tostring(myName).."-"..tostring(myRealm))        
      end      
   end   
end



function test()
	print("TEST");
	DisplayElesWindow();
end


function DisplayElesWindow()
	local t,tt = nil;
	
	ElesModFrame:Show(); 
	ElesModFrame_Title:SetText("Elerion's Professions Mod V"..tostring(version).."");

	t = _G['EleDataFrameRealm_Field_Field'];	t:SetText("Realm:");
	t = _G['EleDataFrameRealm_Value_Value'];	t:SetText(" "..tostring(Cap(myRealm))); t:SetTextColor(0, 1, 0, 0.5)	
	t = _G['EleDataFrameName_Field_Field'];		t:SetText("Player:");
	t = _G['EleDataFrameName_Value_Value'];		t:SetText(" "..tostring(Cap(me))); t:SetTextColor(1, 1, 0, 1)	

	t = _G['EleDataFrameStatus_Field_Field'];	t:SetText("Mod Status:");
	t = _G['EleDataFrameStatus_Value_Value'];	t:SetText(" "..tostring( ( enabled and "Enabled" or "Disabled" ) ));	
	if enabled then 
		t:SetTextColor(0, 1, 0, 1)
	else
		t:SetTextColor(1, 0, 0, 1)
	end

	for i=1,4,1 do	t = _G['EleDataFrameProf'..i]; t:Hide(); end

	local count=1;
	local os = "";
	for i,v in pairs(savedCats[myRealm][me]) do
		t = _G['EleDataFrameProf'..count]; 
		if t then
			os = "";
			if v["id"] == currentProfessionName then os = "("; end
			os = os .. tostring( v["id"] );
			if v["id"] == currentProfessionName then os = os .. ")"; end
			
			tt = _G['EleDataFrameProf'..count..'_Spacer_Field'  ]; if (tt) then tt:SetText(" Profession"..count..":"); end
			tt = _G['EleDataFrameProf'..count..'_ResetFRM_Field']; if (tt) then tt:SetText(""..os ); end;
			t:Show();
		end
		count = count +1;
	end

end




function updateTradeSkillDetails()
        C_Timer.After(updateTick, function(...) updateTradeSkillWindow() end )
end



function updateTradeSkillWindow(arg)
	if tradeSkillFrame:IsVisible() == false then return end
	drawElesButton();	if enabled == false then return; end
        local skillLineID, skillLineDisplayName, skillLineRank, skillLineMaxRank, skillLineModifier, parentSkillLineID, parentSkillLineDisplayName = C_TradeSkillUI.GetTradeSkillLine()

--        print("currentProfessionName: "..tostring(skillLineID));        print("currentProfessionName: "..tostring(currentProfessionName));        print("currentProfessionID: "..tostring(currentProfessionID));

        if ( skillLineID == nil ) then  print("No TradeskillID."); return  end   
    
        currentProfessionName = parentSkillLineDisplayName;
        currentProfessionID   = parentSkillLineID	
    
        if currentProfessionName == nil and currentProfessionID == nil then 
           if ( skillLineID ) then 
              currentProfessionID   = skillLineID;
              currentProfessionName = skillLineDisplayName;
           else 
              return
           end
        end
    
        checkSavedCats(currentProfessionID,currentProfessionName);
        
        
        if sizeOfArray( savedCats[myRealm][me][currentProfessionID]["data"][mode] ) == 0 then
        	collapseAllTopCategories()
        	return 
        end
        
        data = savedCats[myRealm][me][currentProfessionID]["data"][mode];
	for k,v in pairs(data) do
	        ignoreSetCategory = true;
		TSHook:SetCategoryCollapsed(k,v);		--print("Setting TSID: "..tostring(k).." to: "..tostring(v));
	end
	
	 C_Timer.After(updateTick, function(...) updateTradeSkillWindowRanks() end )
	 if ElesModFrame:IsVisible() then
	 	DisplayElesWindow();
	 end
end


function collapseAllTopCategories()
	local topCats = { }
	local skillLineID, skillLineDisplayName, skillLineRank, skillLineMaxRank, skillLineModifier, parentSkillLineID, parentSkillLineDisplayName = C_TradeSkillUI.GetTradeSkillLine()
        if ( skillLineID == nil ) then  print("No TradeskillID."); return  end   
        t = sizeOfArray(savedCats[myRealm][me][currentProfessionID]["data"][mode]);
        list = getListOfCats()
        for id,name in pairs(list) do 
        	ignoreSetCategory=true; 
        	TSHook:SetCategoryCollapsed(id, true);   --print("Collapsing CAT: "..tostring(id).." name: "..tostring(name));
		if savedCats[myRealm][me][currentProfessionID]["data"][mode] then  else savedCats[myRealm][me][currentProfessionID]["data"][mode] = { }; end
        	savedCats[myRealm][me][currentProfessionID]["data"][mode][id] = true;
        end
        --print("First time use detected. All Categories Collapsed.");
end



function updateTradeSkillWindowRanks()
	local par = TradeSkillFrameScrollChild;   if par:IsVisible() == false then print("Not Visible."); return; end
	
	local kids = { par:GetChildren() }

	for _,ob in ipairs(kids) do
	    if ob:GetObjectType() == "Button" then
	      disText = ob:GetText();
	      if disText == nil then return; end
	      if string.match(disText,"Plans")       or string.match(disText,"Inscription") or string.match(disText,"Alchemy")     or
	         string.match(disText,"Designs")     or string.match(disText,"Mining")      or string.match(disText,"Herbalism")   or
	         string.match(disText,"Enchanting")  or string.match(disText,"Patterns")    or string.match(disText,"Tinkering")   then
	          local child = getFirstObjById(ob, "StatusBar"); 
	          if child == nil then return; end
	          if child.currentRank ==nil or child.maxRank == nil then return; end
	          local cR      = child.currentRank;  if tostring(cR)      == "nil" then cR = 0;      end
	          local maxRank =  child.maxRank;     if tostring(maxRank) == "nil" then maxRank = 0; end
   		  child.Rank:SetFormattedText("%d/%d", cR, maxRank);
	      end
	    end
	end
end


function hookedSetCategoryCollapsed(obj, catID,status)
    if ignoreSetCategory == true then ignoreSetCategory= false; return end

    local skillLineID, skillLineDisplayName, skillLineRank, skillLineMaxRank, skillLineModifier, parentSkillLineID, parentSkillLineDisplayName = C_TradeSkillUI.GetTradeSkillLine()
    if ( skillLineID == nil ) then  print("No TradeskillID."); return  end   
    
    currentProfessionName = parentSkillLineDisplayName;
    currentProfessionID   = parentSkillLineID
    
    
   if currentProfessionName == nil and currentProfessionID == nil then 
               if ( skillLineID ) then 
                  currentProfessionID = skillLineID;
                  currentProfessionName = skillLineDisplayName;
               else 
                  return
               end
    end
    
    if not savedCats[myRealm][me][currentProfessionID] then       
    	print("That profession ("..currentProfessionName..")("..tostring(parentSkillLineID)..") has not been created yet..creating...("..tostring(myRealm).." -> "..tostring(me)..")")    
    	savedCats[myRealm][me][currentProfessionID] = { }
        savedCats[myRealm][me][currentProfessionID]["id"] = ""..currentProfessionName
        savedCats[myRealm][me][currentProfessionID]["data"] = { }
        savedCats[myRealm][me][currentProfessionID]["data"]["Unlearnt"] = { }
        savedCats[myRealm][me][currentProfessionID]["data"]["Learnt"]   = { }
    end
    
    categoryInfo = C_TradeSkillUI.GetCategoryInfo(catID); 			
    
    if not savedCats[myRealm][me][currentProfessionID] then			
       savedCats[myRealm][me][currentProfessionID] = { }
       if not savedCats[myRealm][me][currentProfessionID]["data"][mode][catID] then  
          savedCats[myRealm][me][currentProfessionID]["data"][mode][catID] = { } 		
       end
       savedCats[myRealm][me][currentProfessionID]["data"][mode][catID]["status"] = status		
    else										
       savedCats[myRealm][me][currentProfessionID]["data"][mode][catID] = status
    end

end

-- **********************************************************************************************************



function drawElesButton()
	if not ElesButton then
	        ElesButton = { }
	        mf = TradeSkillFrameCloseButton; mf = TradeSkillFrame.FilterButton;
		ElesButton = CreateFrame("Button","EleProfsButton",mf,"UIPanelButtonTemplate");
        	ElesButton:SetPoint("RIGHT",mf,"RIGHT",-27,26)
        	ElesButton:SetFrameStrata("HIGH");
        	ElesButton:SetWidth(65);
        	if enabled == true then ElesButton:SetText("EP is ON"); 
        	else			ElesButton:SetText("EP is OFF"); end
        	
        	ElesButton:SetScript("OnMouseDown", drawElesButtonClicked );
	end
end



function drawElesButtonClicked(who,args)
	if args == "RightButton" then 
		 if ElesModFrame:IsVisible() then ElesModFrame:Hide();
		 else                             ElesModFrame:Show(); DisplayElesWindow(); end
		 return;
	end
	if enabled == true then 
		enabled = false; ElesButton:SetText("EP is OFF"); 
		print("Elerion's Professions Mod disabled."); 
	else			
		enabled = true;	 ElesButton:SetText("EP is ON"); 
		print("Elerion's Professions Mod enabled."); 
		updateTradeSkillDetails();
	end
	if enabled == true then savedCats['status'] = "Enabled"; else savedCats['status'] = "Disabled"; end
end

-- **********************************************************************************************************
-- **********************************************************************************************************
-- **********************************************************************************************************



function TS_OnEvent_Hook(who, event, ...)
--   print("["..tostring(who).."] ["..tostring(event).."]");
   
   if event == "TRADE_SKILL_LIST_UPDATE" then updateTradeSkillDetails(); end
   
   if who == TradeSkillFrame.RecipeList.UnlearnedTab and event=="LeftButton" then
   	mode = "Unlearnt";
   	if enabled == true then updateTradeSkillDetails(); end
   	if DEBUG then print("TAB UnLearnt clicked"); end
   end
   if who == TradeSkillFrame.RecipeList.LearnedTab and event=="LeftButton" then
   	mode = "Learnt";
   	if enabled == true then updateTradeSkillDetails(); end
   	if DEBUG then print("TAB Learnt clicked"); end
   end
   
end




-- **************************************************************************************************************************** --
--COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS 
--COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS 
-- **************************************************************************************************************************** --

function ElesMod_Commands(msg)
   local num
   local args = {}
   local ip;
   local t;
   
   for word in string.gmatch(msg, "[^%s]+") do	table.insert(args, word);   end
    if isTable(args) then    	
       if #args == 0 then 
          print("Elerions Professions Mod - Commands:")
          print("    reset <char|all>");
          print("    help ");
          return
       end
    end
   
   local cmd = string.lower(args[1])
 

    -- ------------------------------------------------------
    if cmd == "test" then test(); end

    if cmd == "show" then ElesModFrame:Show(); DisplayElesWindow(); end
    if cmd == "hide" then ElesModFrame:Hide(); end
    
    if cmd == "reset" then       
        if #args > 1 then 
           ok=false
           if args[2] == "all" then 
               savedCats = { }; print("All character(s) professions settings reset.");   
               ok=true
               end
           if args[2] == "char" then 
               savedCats[myRealm][me] = { }; print(""..myName.."-"..tostring(myRealm).."'s profession settings erased.");   
               ok=true
               end
           if ok == false then 
              print("Elerion's Professions Mod - Command 'reset': Unknown switch '"..tostring(args[2]).."'.") 
              end
        else 
           print("Elerion's Professions Mod - Usage: reset all OR reset char");
        end
        
    end

    -- ------------------------------------------------------
    
    if (cmd == "help" or cmd == "-h") then
    	 DEFAULT_CHAT_FRAME:AddMessage("Elerion's Professions Mod V"..tostring(version).." by Elerion (Nagrand-EU)");
    end

    -- ------------------------------------------------------
    
end



--COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS 
--COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS COMMANDS 
-- **************************************************************************************************************************** --

-- **********************************************************************************************************
-- **********************************************************************************************************
-- **********************************************************************************************************



function ResetProfession(who)
--	print("ResetProfession ("..tostring( who ) .. " <--> "..tostring(who:GetName()));

	local id = -1;
	local tpn = ""

	t = who:GetParent(); t=t:GetName(); t = t .. "_Field"; t = _G[t];
	if not t then return; end
	for i,dat in pairs(savedCats[myRealm][me]) do
--		print( tostring( "["..dat["id"] ) .. "] -> ["..tostring(t:GetText()).."]");
		if dat["id"] == t:GetText() or "("..dat["id"]..")" == t:GetText() then  
			id = i;  
			tpn = t:GetText();
		end
	end
	if id >= 0 then
		savedCats[myRealm][me][id] = nil
		print("Profession: "..tostring(tpn).." settings forgotten.");
		DisplayElesWindow();
	end
end


function checkSavedCats(profID,profName)
    if not savedCats                      then savedCats                      = { } end
    if not savedCats[myRealm]             then savedCats[myRealm]             = { } end
    if not savedCats[myRealm][me]         then savedCats[myRealm][me]         = { } end

    if profID == nil or profName == nil then 
       --print("Cannot check data, Profession is not returning a Profession ID.");    
       return
    end

    if not savedCats[myRealm][me][profID] then 
--        print("ProfID: '"..tostring(profID).."'");
    	savedCats[myRealm][me][profID] = { }; 
    	savedCats[myRealm][me][profID]["data"] = { }; 
    	savedCats[myRealm][me][profID]["data"]["Learnt"] = { }; 
    	savedCats[myRealm][me][profID]["data"]["Unlearnt"] = { }; 
    	savedCats[myRealm][me][profID]['id'] = profName; end
    
end


function getListOfCats()
   local list    = { }
   local catName = nil
   
   local categories = { C_TradeSkillUI.GetCategories() };
	 
   for i, categoryID in ipairs(categories) do
      categoryData = C_TradeSkillUI.GetCategoryInfo(categoryID);
      catName =  categoryData.name;  
      catID   =  categoryData.categoryID;
      if not string.match(catName,"Training") then list[catID] = catName; end
    end
    return list;
end


function sizeOfArray(which)
 local count = 0
 if type(which) ~= "table" then return 0; end
 
 for i,data in pairs(which) do
    count = count + 1
 end
 return count
end





function isTable(t) return type(t) == 'table' end


function Cap(str)
    local s;
    local e;
    s = string.sub(str,0,1); s = string.upper(s);
    e = string.sub(str,2);
    return s..e;
end


dprintString = ""
function dprint(mess,printNow)
	if mess == nil or mess == "" or printNow == true then
	        if printNow == true then dprintString = dprintString .. mess; end
		print(dprintString);
		dprintString = "";
	else 
		dprintString = dprintString .. mess;
	end
	return true;
end


function getFirstObjById(obj, id)
   local child;
   
   if type(obj) == 'string' then return -1; end
   if type(id)  == 'table ' then return -2; end

   local kids  = { obj:GetChildren() }
   for _, child in ipairs(kids) do   
     --print( child:GetObjectType() );
     if child:GetObjectType() == id then return child; end
   end
   return nil;
end


function dumpTable(tab,name)
 if type(tab) ~= "table" then print("Expected TABLE, got: "..type(tab).."."); return end
 print("["..tostring(name).."]:-");
 for i,data in pairs(tab) do
 	print("["..tostring(i).."] -> ["..tostring(data).."]");
 end
end


function EleTest1(what)
  print("Eles Mod MouseOver Linkup:");
  print( "Type: "..tostring(what:GetObjectType())..', Name: "'..tostring(what:GetName())..'"' );
  p = what:GetParent(); 
  if not p then      print("No Parent"); return;
  else               print( "Parent Info -> Type: "..tostring(p:GetObjectType())..", Name: "..tostring(p:GetName()) );
  end
  showChildren(p);
end


function showChildren(obj)
        local child = nil;
	local kids  = { obj:GetChildren() };
	local count = 0;
	
        for _, child in ipairs(kids) do
               print( "Type: "..tostring(child:GetObjectType())..", Name: "..tostring(child:GetName()) );
               count=count+1;
       end
       if count == 0 then print("No Children."); end
end

